#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include "dn2smart.h"

struct {
    int coll_type;
    char *coll_type_name;
} coll_types[] = {
    { CLTYPE_Z3950, "Z3950" },
    { CLTYPE_SMART, "SMART" },
    { CLTYPE_TIPSTER, "TIPSTER" }
};

/* returns -1 on error */
int
get_coll_list(coll_list_name, coll_list, num_coll_list)
char *coll_list_name;
COLL_LIST_ENTRY **coll_list;
int *num_coll_list;
{
    struct stat stat_buf;
    char *coll_file_text;	/* NOTE: we never deallocate this space */
    FILE *cf;
    int i, j, num_colls, num_coll_types;
    char *cp;
    COLL_LIST_ENTRY *coll_lists;

    num_coll_types = sizeof(coll_types) / sizeof (coll_types[0]);

    if (-1 == stat(coll_list_name, &stat_buf))
	return(-1);

    if ((char *)0 == (coll_file_text = (char *)malloc(stat_buf.st_size+1)))
	return(-1);
    
    if ((FILE *)0 == (cf = fopen(coll_list_name, "r")))
	return(-1);
    if (stat_buf.st_size != fread(coll_file_text, 1, stat_buf.st_size, cf))
	return(-1);
    (void) fclose(cf);
    coll_file_text[stat_buf.st_size] = '\0';
    
    num_colls = 0;
    cp = coll_file_text;
    while (cp = strchr(cp, '\n')) {
	cp++;
	num_colls++;
    }

    coll_lists = (COLL_LIST_ENTRY *)malloc(num_colls * sizeof(COLL_LIST_ENTRY));
    if ((COLL_LIST_ENTRY *)0 == coll_lists)
	return(-1);
    
    cp = coll_file_text;
    for (i = 0; i < num_colls; i++) {
	coll_lists[i].coll_name = cp;
	cp = strchr(cp, '\t');
	*cp++ = '\0';
	coll_lists[i].coll_type = -1;
	for (j = 0; j < num_coll_types; j++) {
	    if (!strncmp(cp, coll_types[j].coll_type_name,
				    strlen(coll_types[j].coll_type_name))) {
		coll_lists[i].coll_type = coll_types[j].coll_type;
		break;
	    }
	}
	if (-1 == coll_lists[i].coll_type)
	    return(-1);
	cp = strchr(cp, '\t');
	cp++;
	coll_lists[i].parameters = cp;
	cp = strchr(cp, '\n');
	*cp++ = '\0';
    }
    
    *coll_list = coll_lists;
    *num_coll_list = num_colls;
    return(0);
}
