static char *sccsid="@(#)dn2doc.cc	1.7";
// Contains the definitions of the DocumentData class, DataClass, and AttributeClass

#define SP_MULTI_BYTE
#include "config.h"
#include "Boolean.h"
#include <iostream>
#include <fstream>
#include <iomanip.h>
#include <string>
#include <cstdlib>
#include "dn2doc.h"

ostream &operator<<(ostream &, SGMLApplication::CharString *);
ostream &operator<<(ostream &, SGMLApplication::CharString);

const char * const DocumentData::NodeNameArray[] = {"EMPTY","APP-SE","SE-APP","SE-APP-HELP","SE-APP-EXPL",
				       "SE-APP-DOCFREQ","SE-APP-COLLFREQ","SE-APP-INTERNAL-ID","SE-APP-MATCHES",
				       "CONTEXT","FULL-TERM",
				       "TEXT","INDEPENDENT","AND","OR","AND-NOT","HEAD-RELATION","OTHER-OPER",
				       "INFO-NEED","DOCID","DOC-COLLECTION","B-AND","B-OR","B-AND-NOT",
				       "RESTRICT-SET","FEEDBACK-INFO","DOCID-REL","TEXT-REL","COMMENT",
				       "ANN-ATTR","ANN-TYPE","ATTR-NAME","ATTR-TYPE","ATTR-VALUE","MERGE-INFO","DN2"};

DocumentData::DocumentData() {
    // Initialization of class documentdata

    head.nodetype = EMPTY;
    head.parent = (NodeStruct *)NULL;
  
    current = &head;
    parse_error = 0;
}

DocumentData::~DocumentData(){
    // Destroy it
    // nothing specific needs to be done here yet
}


void DocumentData::start_node(const NodeEnum type_of_node) {
    // adds a new node to the list of nodes in the current node

    NodeStruct *newnode;

    if (current->nodetype == EMPTY) {
	// This the very first node of the document
	current->nodetype = type_of_node;
    } else {
	// First node already filled do default processing
	newnode = new NodeStruct;
	newnode->nodetype = type_of_node;
	newnode->parent = current;

	// insert this node into the current node's nodes list
	current->children.push_back(newnode);
	
	// set the DocumentClass' current pointer to this node
	current = newnode;
    }
}


void DocumentData::start_node(const string type_of_node) {
  NodeEnum tmp;

  if (type_of_node == "APP-SE")
    tmp = APP_SE;
  else
    if (type_of_node == "SE-APP")
      tmp = SE_APP;
  else
    if (type_of_node == "SE-APP-HELP")
      tmp = SE_APP_HELP;
  else
    if (type_of_node == "SE-APP-EXPL")
      tmp = SE_APP_EXPL;
  else
    if (type_of_node == "SE-APP-DOCFREQ")
      tmp = SE_APP_DOCFREQ;
  else
    if (type_of_node == "SE-APP-COLLFREQ")
      tmp = SE_APP_COLLFREQ;
  else
    if (type_of_node == "SE-APP-INTERNAL-ID")
      tmp = SE_APP_INTERNAL_ID;
  else
    if (type_of_node == "SE-APP-MATCHES")
      tmp = SE_APP_MATCHES;
  else
    if (type_of_node == "CONTEXT")
      tmp = CONTEXT;
  else
    if (type_of_node == "FULL-TERM")
      tmp = FULL_TERM;
  else
    if (type_of_node == "TEXT")
      tmp = TEXT;
  else
    if (type_of_node == "INDEPENDENT")
      tmp = INDEPENDENT;
  else
    if (type_of_node == "AND")
      tmp = AND;
  else
    if (type_of_node == "OR")
      tmp = OR;
  else
    if (type_of_node == "AND-NOT")
      tmp = AND_NOT;
  else
    if (type_of_node == "HEAD-RELATION")
      tmp = HEAD_RELATION;
  else
    if (type_of_node == "OTHER-OPER")
      tmp = OTHER_OPER;
  else
    if (type_of_node == "INFO-NEED")
      tmp = INFO_NEED;
  else
    if (type_of_node == "DOCID")
      tmp = DOCID;
  else
    if (type_of_node == "DOC-COLLECTION")
      tmp = DOC_COLLECTION;
  else
    if (type_of_node == "B-AND")
      tmp = B_AND;
  else
    if (type_of_node == "B-OR")
      tmp = B_OR;
  else
    if (type_of_node == "B-AND-NOT")
      tmp = B_AND_NOT;
  else
    if (type_of_node == "RESTRICT-SET")
      tmp = RESTRICT_SET;
  else
    if (type_of_node == "FEEDBACK-INFO")
      tmp = FEEDBACK_INFO;
  else
    if (type_of_node == "DOCID-REL")
      tmp = DOCID_REL;
  else
    if (type_of_node == "TEXT-REL")
      tmp = TEXT_REL;
  else
    if (type_of_node == "COMMENT")
      tmp = COMMENT;
  else
    if (type_of_node == "ANN-ATTR")
      tmp = ANN_ATTR;
  else
    if (type_of_node == "ANN-TYPE")
      tmp = ANN_TYPE;
  else
    if (type_of_node == "ATTR-NAME")
      tmp = ATTR_NAME;
  else
    if (type_of_node == "ATTR-TYP")
      tmp = ATTR_TYPE;
  else
    if (type_of_node == "ATTR-VALUE")
      tmp = ATTR_VALUE;
  else
    if (type_of_node == "MERGE-INFO")
      tmp = MERGE_INFO;
  else
    if (type_of_node == "DN2")
      tmp = DN2;
  else
    tmp = EMPTY;

  if (tmp != EMPTY) {
      start_node(tmp);
  } else {
      cerr << "EMPTY type in start_node" << endl;
      throw parse_error;
  }
}


void DocumentData::start_node(const char *type_of_node) {
    // convert type_of_node to string and call start_node
    string tmpstring = type_of_node;
    start_node(tmpstring);
}

void DocumentData::start_node(const SGMLApplication::CharString type_of_node) {
    // convert CharString into string
    // and then call start_node(string variable)
    
    string tmpstring;
  
    for (int i=0; i<type_of_node.len; i++)
      tmpstring += static_cast<char>(type_of_node.ptr[i]);
    start_node(tmpstring);
}


void DocumentData::add_data(const SGMLApplication::CharString *data) {
    // appends new data to the end of the data list of the current node  

    DataClass tmpdata(data);
    current->datavector.push_back(tmpdata);
}

void DocumentData::add_data(const char *data) {
    // appends new data to the end of the data list of the current node

    DataClass tmpdata(data);
    current->datavector.push_back(tmpdata);
}


void DocumentData::add_attribute(const SGMLApplication::CharString *attribname, const SGMLApplication::CharString *attribvalue) {
    // appends attribute to end of the attribute list of the current node

    AttributeClass tmpattrib(attribname, attribvalue);
    current->attributevector.push_back(tmpattrib);
}

void DocumentData::add_attribute(const char *attribname, const char *attribvalue) {
    // appends attribute to end of the attribute list of the current node

    AttributeClass tmpattrib(attribname, attribvalue);
    current->attributevector.push_back(tmpattrib);
}


void DocumentData::end_node() {
    // stops adding subnodes to the current node
    // and moves the current pointer back up a level

    if (current->parent) {
	current = current->parent;
    }
}

void DocumentData::error_cleanup() {
    // received SGML error during parsing
    // shutdown processing by invoking 
    // end_node() until current==head
    // Print out some info about where we
    // are in the processing.
    NodeStruct *nodeptr = current;
    
    cerr << "The error occurred in this node:" << endl;
    cerr << get_nodetype(current) << endl;
    while ((nodeptr = nodeptr->parent)) {
	cerr << "parent: " << get_nodetype(nodeptr) << endl;
    };
}

string DocumentData::return_dn2() {
    // returns a string containing the SGML form
    // of the parsed DN2.

    string outstring;

    outstring = "<!DOCTYPE DN2 PUBLIC \"-//TIPSTER//DTD DN2//EN\">"; 
    outstring += get_nodes(&head);

    return outstring;
}

string DocumentData::get_nodes(const NodeStruct *node) {
    // returns a string in SGML of a recursive descent from node

    string nodestr;

    nodestr = "<" + get_nodetype(node) + " " + get_nodeattributes(node) +
      ">" + get_nodedata(node);

    for (int i=0; i < node->children.size(); i++) {
	nodestr += get_nodes(node->children[i]);
    }
    nodestr += "</" + get_nodetype(node) + ">";
    return nodestr;
}

string DocumentData::get_nodetype(const NodeStruct *node) {
    string nodevalue;
    // Why don't I use a the nodetype as an index into the NodeNameArray???

    // nodevalue = NodeNameArray(node->nodetype);
    switch(node->nodetype) {
      case DN2:
	nodevalue = "DN2";
	break;
      case MERGE_INFO:
	nodevalue = "MERGE-INFO";
	break;
      case APP_SE:
	nodevalue = "APP-SE";
	break;
      case SE_APP:
	nodevalue = "SE-APP";
	break;
      case SE_APP_HELP:
	nodevalue = "SE-APP-HELP";
	break;
      case SE_APP_EXPL:
	nodevalue = "SE-APP-EXPL";
	break;
      case SE_APP_DOCFREQ:
	nodevalue = "SE-APP-DOCFREQ";
	break;
      case SE_APP_COLLFREQ:
	nodevalue = "SE-APP-COLLFREQ";
	break;
      case SE_APP_INTERNAL_ID:
	nodevalue = "SE-APP-INTERNAL-ID";
	break;
      case SE_APP_MATCHES:
	nodevalue = "SE-APP-MATCHES";
	break;
      case CONTEXT:
	nodevalue = "CONTEXT";
	break;
      case FULL_TERM:
	nodevalue = "FULL-TERM";
	break;
      case TEXT:
	nodevalue = "TEXT";
	break;
      case INDEPENDENT:
	nodevalue = "INDEPENDENT";
	break;
      case AND:
	nodevalue = "AND";
	break;
      case OR:
	nodevalue = "OR";
	break;
      case AND_NOT:
	nodevalue = "AND-NOT";
	break;
      case HEAD_RELATION:
	nodevalue = "HEAD-RELATION";
	break;
      case OTHER_OPER:
	nodevalue = "OTHER-OPER";
	break;
      case INFO_NEED:
	nodevalue = "INFO-NEED";
	break;
      case DOCID:
	nodevalue = "DOCID";
	break;
      case DOC_COLLECTION:
	nodevalue = "DOC-COLLECTION";
	break;
      case B_AND:
	nodevalue = "B-AND";
	break;
      case B_OR:
	nodevalue = "B-OR";
	break;
      case B_AND_NOT:
	nodevalue = "B-AND-NOT";
	break;
      case RESTRICT_SET:
	nodevalue = "RESTRICT-SET";
	break;
      case FEEDBACK_INFO:
	nodevalue = "FEEDBACK-INFO";
	break;
      case DOCID_REL:
	nodevalue = "DOCID-REL";
	break;
      case TEXT_REL:
	nodevalue = "TEXT-REL";
	break;
      case COMMENT:
	nodevalue = "COMMENT";
	break;
      case ANN_ATTR:
	nodevalue = "ANN-ATTR";
	break;
      case ANN_TYPE:
	nodevalue = "ANN-TYPE";
	break;
      case ATTR_NAME:
	nodevalue = "ATTR-NAME";
	break;
      case ATTR_TYPE:
	nodevalue = "ATTR-TYP";
	break;
      case ATTR_VALUE:
	nodevalue = "ATTR-VALUE";
	break;
      default:
	nodevalue = "EMPTY!!!";
	break;
    };

    return nodevalue;
}

string DocumentData::get_nodeattributes(const NodeStruct *node) {
    // returns a string with the attributes of the node
    // in the SGML form.

    string attribstr;

    for (int i=0; i<node->attributevector.size(); i++) {
	attribstr += " ";
	attribstr += node->attributevector[i].get_attributename();
	attribstr += "=";
	attribstr += node->attributevector[i].get_attributevalue(); 
    }

    return attribstr;
}

string DocumentData::get_nodedata(const NodeStruct *node) {
    // returns a string with the data events for the node
    // concatenated.

    string datastr;
    for (int i=0; i<node->datavector.size(); i++) {
	datastr += node->datavector[i].get_data();
    }
    return datastr;
}

string DocumentData::return_tcldn2() {
    // returns a string containing the tcl representation 
    // parsed DN2.
    // the tcl list  format
    //  node = {nodetype {{attrb1 value} {attrb2 value} ...} {{childnode1} {childnode2} ...}}
    //
    // Several of the nodetypes have a special value attribute.  This attribute will hold
    // the data occurring between the starttag and endtag.  For example qtd-text contains
    // data that should be quoted.  This quoted data will appear between the start and end
    // tags.

    string outstring;
    outstring = get_tclnodes(&head);
    return outstring;
}

string DocumentData::get_tclnodes(const NodeStruct *node) {
    string outstring;

    outstring = "{" + get_nodetype(node) + " ";
  
    outstring += get_tclnodeattribs(node);
    outstring += "{"; // open list of subnodes
    for (int i=0; i<node->children.size(); i++) {
	outstring += get_tclnodes(node->children[i]);
    };
    outstring += "} "; // closes list of subnodes
    outstring += "} "; // closes current node

    return outstring;
}

string DocumentData::get_tclnodeattribs(const NodeStruct *node) {
    int numofattribs;
    string outstring;
    bool attributes_were_added = false;
    bool data_was_added = false;
    outstring = "{"; // open attrib section

    // output data events into the value attribute for a subset of nodetypes

    // put attributes in attributevector into the tclstring
    if ((numofattribs = node->attributevector.size()) > 0) {
	for (int i=0; i < numofattribs; i++) {
	    outstring += "{";
	    outstring += node->attributevector[i].get_attributename();
	    outstring += " ";
	    outstring += node->attributevector[i].get_attributevalue();
	    outstring += "} ";
	}
	attributes_were_added = true;
    }
    // put any data events into the value attribute
    if (node->datavector.size()>0) {
	outstring += "{value ";
	for (int i=0; i<node->datavector.size(); i++){
	    outstring += convert_to_tclstring(node->datavector[i].get_data());
	}
	outstring +=  "} ";
	data_was_added = true;
    }
    if (!data_was_added && !attributes_were_added) {
	outstring += "{}";
    }
    outstring += "} ";  // closes attrib section
    return outstring;
}

string DocumentData::convert_to_tclstring(const string& instr) {
    // converts a string into it's escaped Tcl equivalent
    string outstring;

    for(int i=0; i < instr.length(); i++) {
	switch (instr[i]) {
	  case ' ': // insert '\' before char
	  case '{':
	  case '}':
	  case '[':
	  case ']':
	  case '"':
	    outstring += "\\";
	    outstring += instr[i];
	    break;
	  case '\n': // replace char with "\n"
	    outstring += "\\n";
	    break;
	  case '\t': // replace char with "\t"
	    outstring += "\\t";
	    break;
	  case '\r': // replace char with "\r"
	    outstring += "\\r";
	    break;
	  default:
	    outstring += instr[i];
	};
    }
    return outstring;
}

//
// Define the AttributeClass methods
//

// ctor
AttributeClass::AttributeClass() {}

// ctor with two CharString ptrs
AttributeClass::AttributeClass(const SGMLApplication::CharString *name, const SGMLApplication::CharString *value) {
  // set AttributeName
  char tmpstr1[name->len+1];
  int i;
  for (i=0; i < name->len; i++) {
    tmpstr1[i] = static_cast<char>(name->ptr[i]);
  }
  tmpstr1[i] = '\0';
  AttributeName = tmpstr1;

  // set AttributeValue
  char tmpstr2[value->len+1];
  for (i=0; i < value->len; i++) {
    tmpstr2[i] = static_cast<char>(value->ptr[i]);
  }
  tmpstr2[i] = '\0';
  AttributeValue = tmpstr2;
}

AttributeClass::AttributeClass(const char *name, const char *value) {
  AttributeName = name;
  AttributeValue = value;
}

AttributeClass::~AttributeClass() {}

string AttributeClass::get_attributename() const {
  return AttributeName;
}

string AttributeClass::get_attributevalue() const {
  return AttributeValue;
}

void AttributeClass::set_attributename(const SGMLApplication::CharString *name) {
  // loop through the CharString converting name->ptr[] to char
  // then set AttributeName to the resulting char string
  char tmpstr[name->len+1];
  int i;
  for (i=0; i < name->len; i++) {
    tmpstr[i] = static_cast<char>(name->ptr[i]);
  }
  tmpstr[i] = '\0';
  AttributeName = tmpstr;
}

void AttributeClass::set_attributevalue(const SGMLApplication::CharString *value) {
  // loop through the CharString converting name->ptr[] to char
  // then set AttributeValue to the resulting char string
  char tmpstr[value->len+1];
  int i;
  for (i=0; i < value->len; i++) {
    tmpstr[i] = static_cast<char>(value->ptr[i]);
  }
  tmpstr[i] = '\0';
  AttributeValue = tmpstr;
}

//
// Define the DataClass methods
//

DataClass::DataClass() {}

DataClass::DataClass(const SGMLApplication::CharString *init) {
  // must loop through init converting init->ptr to char *
  // once complete set data to this value
  char tmpstr[init->len+1];
  int i;
  for (i=0; i< init->len ; i++) {
    tmpstr[i] = static_cast<char>(init->ptr[i]);
  }
  tmpstr[i] = '\0';
  data = tmpstr;
}

DataClass::DataClass(const char *init) {
  data = init;
}

// copy constructor
DataClass::DataClass(const DataClass &rhs) {
  data = rhs.data;
}

DataClass::~DataClass() {}

string DataClass::get_data() const {
  return data;
}

void DataClass::set_data(const SGMLApplication::CharString *value){
  char tmpstr[value->len+1];
  int i;
  for (i=0; i< value->len ; i++) {
    tmpstr[i] = static_cast<char>(value->ptr[i]);
  }
  tmpstr[i] = '\0';
  data = tmpstr;
}

void DataClass::set_data(const char *value) {
  data = value;
}
