static char sccsid[] = "@(#)dn2parse_string.cc	1.3";

#define SP_MULTI_BYTE
#include "config.h"
#include "Boolean.h"
#include "ParserEventGeneratorKit.h"
#include <iostream>
#include <strstream>
#include <cstdio>
#include <unistd.h>
#include "OutputCharStream.h"
#include "dn2app.h"

const OutputCharStream::Newline nl = OutputCharStream::newline;
const char space = ' ';
const Char re = '\r';





string parsedn2(string& stringin, string& stringout, bool returnsgmlflag)
{
    unsigned nErrors = 0;
    ParserEventGeneratorKit parserKit;
    char *temporaryfile;
    string returnstring;

    // It appears that egp->run() can only accept input from a file
    //  or from standard input.  Here is a kludgy thing to make it
    //  work from a string.  Create a tmp file, write the string,
    //  to it, then pass the filename to the generator.

    // when using this technique the default directory is set to /var/tmp
    //  this really confuses the parser since it can't find a catalog or DTD
    //  SP will read a catalog from a directory specified by the SGML_CATALOG_FILES

    temporaryfile = new char[L_tmpnam]; // defined in cstdio, sysdependant length of unique filename
    if (tmpnam(temporaryfile) == NULL) {
	cerr << "Couldn't create a temp file!" << endl;
	return "1";
    } else {
	// open the file and put the dn2 string into it
	ofstream outfile(temporaryfile);
	outfile << stringin;
	outfile.close();
    }
    
    // Use all the arguments after argv[0] as filenames.
    EventGenerator *egp = parserKit.makeEventGenerator(1, &temporaryfile);
    DN2Application app;

    try {
	nErrors = egp->run(app);
    }
    catch (SGMLError &err) {
	returnstring = err.errorstring;
	app.cleanup();
	unlink(temporaryfile);
	delete egp;
	return returnstring;
    }

    if(returnsgmlflag)
      stringout = app.GetDN2();
    else
      stringout = app.GetTclDN2();
    
    unlink(temporaryfile);
    delete egp;
    returnstring = "0";
    return returnstring;
}







