/* @(#)tmp.h	1.1 */
/*                            SERVERZ.H                            */

/*
 *  Copyright (c) 1992 Stanford Leland Junior University
 *
 *  Commercial use prohibited
 *
 *  Author: Harold Finkbeiner (Harold@Forsythe.Stanford.Edu)
 */

#ifndef SERVERS_H
#define SERVERS_H

/*
   The following table describes some of the various Z39.50
   servers which can be connected to by just using a name.

   I grew tired of typing in the host name time after time
   and having to type them correctly.
*/

typedef struct select_description
    {
        char *match;
        char *name;
        char *host;
        char *port;
	char *authorize;
    } SELECT_ENTRY, *SELECT_REFERENCE;

static SELECT_ENTRY select_table[] =
    {
        {"STOWE",              "default",           "202.135.95.2",           "",      ""},
        {"DPL",              "DPL",           "z3950.carl.org",           "",      ""},
        {"UNC",              "UNC",           "z3950.carl.org",           "",      ""},
        {"SUP_SYL",              "SYLLABI",           "supct.law.cornell.edu",           "",      ""},
        {"SUP_HERMES",              "HERMES",           "supct.law.cornell.edu",           "",      ""},
        {"MELVYL_CAT",              "CAT",           "melvyl.ucop.edu",           "",      ""},
        {"MELVYL_TEN",              "TEN",           "melvyl.ucop.edu",           "",      ""},
        {"RMIT",              "ZIW",           "z3950.mds.rmit.edu.au",           "",      ""},
        {"LC_BOOKS",            "BOOKS",         "ibm2.loc.gov",              "",      ""},
        {"LC_PROD",            "BOOKS",         "ibm2.loc.gov",            "2210",      ""},
        {"LC_NAMES",            "NAMES",         "ibm2.loc.gov",              "",      ""},
        {"OCLC_CAT",            "WorldCat",      "tikal.dev.oclc.org",        "",      ""},
        {"OCLC_ERIC",           "ERIC",          "tikal.dev.oclc.org",        "",      ""},
        {"BOOKS",               "books",         "z3950.bell-labs.com",    "",      ""},
        {"RLG",                 "BIB",           "zinc.rlg.org",          "",      ""},

        /* Infocal must be last */

        {"INFOCAL",             "cat",      "infocal.berkeley.edu",           "",      ""}
    };

#define select_total ((int) (sizeof(select_table) / sizeof(select_table[0])))

#endif
